// moving DS JS to its own file for easy change and inclusion in templates
var stSearchKey = '';
var activeDocName = '';
var currentDocNames = new Set();
var docLang = $(document.documentElement).attr('lang');

var customRenderPagination = function (type, currentPage, totalPages) {
    var pages = '<div class="st-page">',
        previousPage,
        nextPage;
    var pageNumbers = [];
    var startWith = 1;
    var maxNumbers = 100;
    var goFirst = '<span class="flaticon-arrows"/>';
    var goPrevious = '<span class="flaticon-back"/>';
    var goNext = '<span class="flaticon-next"/>';
    var goLast = '<span class="flaticon-arrows-1"/>';

    for ( var pageNumber = startWith; pageNumber <= Math.min(startWith + maxNumbers - 1, totalPages); ++pageNumber ) {
        pageNumbers.push(pageNumber);
    }
    if (totalPages >= 1) {
        if (currentPage >= 1) {
            previousPage = currentPage - 1
            if (previousPage == 0) {;
                pages = pages + goFirst;
                pages = pages + goPrevious + '';
            } else {
                pages = pages + '<a href="#" class="ds-st-first" data-hash="true" data-page="1">' +
                    goFirst + '</a>';
                pages = pages + '<a href="#" class="ds-st-prev" data-hash="true" data-page="' +
                    previousPage + '">' + 
                    goPrevious + '</a>';
            }
        }
        startIndex = (currentPage - 3 >= 0) ? currentPage - 3 : 0 ;
        endIndex = (currentPage + 2 <= totalPages) ? currentPage + 3 : totalPages;
        for (var pgNum = startIndex; pgNum <= endIndex; pgNum++) {
            if (pgNum == 0) {
                pages = pages;
            } else if (currentPage == pgNum) {
                pages = pages + pgNum;
            } else {
                pages = pages + '<a href="#" class="st-page" data-hash="true" data-page="' +
                    pgNum + '">' +
                    pgNum + '</a>';
            }
        }
        if (currentPage <= totalPages) {
            nextPage = currentPage + 1;
            if (nextPage >= totalPages) {
                pages = pages + goNext;
                pages = pages + goLast;
            } else {
                pages = pages
                    + '<a href="#" class="ds-st-next" data-hash="true" data-page="' +
                    nextPage + '">' + 
                    goNext + '</a>';
                pages = pages + 
                    '<a href="#" class="ds-st-last" data-hash="true" data-page="' +
                    totalPages +
                    '">' + 
                    goLast + 
                    '</a>';
            }
        }
    }
    pages += "</div>";
    return pages;
};
var customPostRenderFunction = function(data) {
    var totalResultCount = 0;
    var resultsPerPage = null;
    var $resultContainer = this.getContext().resultContainer;
    var spellingSuggestion = null;
    var thisPage = 0;
    var currentQuery = null;
    function htmlEscape(str) {
        return String(str)
        .replace(/&/g, "&amp;")
        .replace(/"/g, "&quot;")
        .replace(/'/g, "&#39;")
        .replace(/</g, "&lt;")
        .replace(/>/g, "&gt;");
    }
    if (data["info"]) {
        $.each(data["info"], function(index, value) {
            totalResultCount += value["total_result_count"];
            resultsPerPage = value["per_page"];
            thisPage = value["current_page"];
            currentQuery = value["query"];
            if (value["spelling_suggestion"]) {
                spellingSuggestion = value["spelling_suggestion"]["text"];
            }
        });
    }
    var noResultsText = docLang === 'en' ? 'No results found for' : '見つかりませんでした。検索語：';
    // do header of results table
    if (totalResultCount > 0) {
        var fromResultNumber = (thisPage - 1) * resultsPerPage + 1;
        var toResultNumber = (thisPage - 1) * resultsPerPage + resultsPerPage;
        var toResultNumberAux = ( toResultNumber < totalResultCount ) ? toResultNumber : totalResultCount;
        $resultContainer.prepend(
            "<span id='st-result-summary'>Showing " +
            fromResultNumber +
            " &ndash;  " +
            toResultNumberAux +
            " out of " +
            totalResultCount +
            " results for &quot;" +
            htmlEscape(currentQuery) +
            "&quot;</span>"
        );
    }
    if (totalResultCount === 0) {
        $resultContainer.html(
            "<div id='st-no-results' class='st-no-results'>" + noResultsText + " &quot;" +
            htmlEscape(currentQuery) +
            "&quot;.</div>"
        );
    }
    if (spellingSuggestion !== null) {
        $resultContainer.append(
            '<div class="st-spelling-suggestion">Did you mean <a href="#" data-hash="true" data-spelling-suggestion="' +
            spellingSuggestion +
            '">' +
            spellingSuggestion +
            "</a>?</div>"
        );
    }
};
var searchResultsRenderFunction = function(document_type, item) {
    book = ( item['book'] == undefined ) ? '' : ' | ' + item['book'];
    description = ( item['description'] == undefined ) ? '' : item['description'];
    displayFlag = ( item['doc-name'] === activeDocName );
    out = '<div class="st-result">'
        + '<h3 class="title">'
        + '<a href="' 
        + item['url']
        + '" class="st-result">'
        + item['title'] + '</a> ' + book + '</h3><p class="st-description">'
        + description + '</p></div>';
    return out;
};
var autoCompleteRenderFunction = function(document_type, item) {
    book = ( item['book'] == undefined ) ? '' : ' | ' + item['book'];
    out = '<div class="st-autocomplete">'
        + '<p class="stac-title">'
        + '<a href="' 
        + item['url']
        + '" class="stac-result">'
        + item['title'] + '</a> ' + book + '</p></div>';
    return out;
};
// modal overlay
var toggleOverlay = function() {
    var containerElement = document.getElementById("st-modal");
    if ( containerElement.style.display === 'none' ) {
        containerElement.style.display = 'block';
    }
};
var inputHandlerFunction = function(event) {
    console.log("inputHandlerFunction called");
    toggleOverlay();
    return true;
};
var getDocnameToFilterBy = function() {
    return "{'page': {'doc-name': " + activeDocName + "}}";
};
var reloadResults = function() {
    $(window).hashchange();
};
var changeFilters = function(event) {
    console.log("changeFilters called");
    var apiCheckbox = document.getElementById("api-checkbox");
    var suffix = apiCheckbox.checked ? "-api" : "" ;
    var radioElements = Array.prototype.slice.call( document.getElementsByClassName('docNames') );
    for (var lmn of radioElements) {
        if ( lmn.checked ) {
            activeDocName = lmn.value + suffix;
            break;
        }
    }
    if ( ! currentDocNames.has(activeDocName) ) {
        console.log("changeFilters: " + activeDocName);
        currentDocNames.add(activeDocName);
        var resultsContainer = document.getElementById("st-results-container");
        var element = document.createElement("div");
        element.setAttribute("id", "st-results-container-" + activeDocName);
        resultsContainer.insertBefore(element, document.getElementById("st-results-container").childNodes[0]);
        initializeSearch(stSearchKey, activeDocName, apiCheckbox.checked);
    }
    for (let dname of currentDocNames.keys()) {
        var container = document.getElementById("st-results-container-" + dname);
        if (dname === activeDocName) {
            container.style.display = 'block';
        } else {
            container.style.display = 'none';
        }
    }
    return true;
};
var initializeSearch = function(key, docName, apiFlag = false) {
    console.log("initializeSearch called: " + docName + " " + apiFlag);
    // set up search
    activeDocName = docName;
    currentDocNames.add(docName);
    var filterBy;
    if ( apiFlag ) {
        if ( docName.substring(0, docName.length - 4) === 'alldocs' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = [
                'dseadmin67','dsesearch67','dsedev67','cql67','dseplanning','dsetrblshoot','docker','opsc67',
                'dseadmin60','dsesearch60','dsedev60','cql60','opsc65',
                'dseadmin51','dsesearch51','dsedev51','cql51','opsc61',
                'dse50','cql33','ddac51','ddaccql','dsbulk',
                'cppdrivers','csharpdrivers','javadrivers','nodejsdrivers','phpdrivers','pythondrivers',
                'kafka','upgrade','devcenter'
            ];
        } else if ( docName.substring(0, docName.length - 4) === 'jajpalldocs' ) {
            key = 'dBUc6S_N-zKdkEA-U6sD';
            filterBy = [
                'jajpdseadmin51','jajpdsearch51','jajpdsedev51','jajpcql51',
                'jajpdse50','jajpcassandra30','jajpcql33',
                'jajpopsc61','jajpupgrade'
            ];
        } else if ( docName.substring(0, docName.length - 4) === 'alldse67' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = ['dseadmin67','dsesearch67','dsedev67','cql67','dseplanning','dsetrblshoot','docker'];
        } else if ( docName.substring(0, docName.length - 4) === 'alldseaux' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = ['kafka','dseplanning','dsetrblshoot','upgrade'];
        } else if ( docName.substring(0, docName.length - 4) === 'alldse60' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = ['dseadmin60','dsesearch60','dsedev60','cql60','dseplanning','dsetrblshoot'];
        } else if ( docName.substring(0, docName.length - 4) === 'alldse51' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = ['dseadmin51','dsesearch51','dsedev51','cql51','dseplanning','dsetrblshoot'];
        } else if ( docName.substring(0, docName.length - 4) === 'jajpalldse51' ) {
            key = 'dBUc6S_N-zKdkEA-U6sD';
            filterBy = ['jajpdseadmin51', 'jajpdsearch51', 'jajpdsedev51', 'jajpcql51'];
        } else if ( docName.substring(0, docName.length - 4) === 'dsecstar50' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = ['dse50','cassandra30','cql33'];
        } else {
            filterBy = docName.substring(0, docName.length - 4);
        }
    } else {
        if ( docName === 'alldocs' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = [
                'dseadmin67','dsesearch67','dsedev67','cql67','dseplanning','dsetrblshoot','docker','opsc67',
                'dseadmin60','dsesearch60','dsedev60','cql60','opsc65',
                'dseadmin51','dsesearch51','dsedev51','cql51','opsc61',
                'dse50','cql33','ddac51','ddaccql','dsbulk',
                'cppdrivers','csharpdrivers','javadrivers','nodejsdrivers','phpdrivers','pythondrivers',
                'kafka','upgrade','devcenter'
            ];
        } else if ( docName === 'jajpalldocs' ) {
            key = 'dBUc6S_N-zKdkEA-U6sD';
            filterBy = [
                'jajpdseadmin51','jajpdsearch51','jajpdsedev51','jajpcql51',
                'jajpdse50','jajpcassandra30','jajpcql33',
                'jajpopsc61','jajpupgrade'
            ];
        } else if ( docName === 'alldse67' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = ['dseadmin67','dsesearch67','dsedev67','cql67','dseplanning','dsetrblshoot','docker'];
        } else if ( docName === 'alldseaux' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = ['kafka','dseplanning','dsetrblshoot','upgrade'];
        } else if ( docName === 'alldse60' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = ['dseadmin60', 'dsesearch60', 'dsedev60','cql60','dseplanning','dsetrblshoot'];
        } else if ( docName === 'alldse51' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = ['dseadmin51', 'dsesearch51', 'dsedev51','cql51','dseplanning','dsetrblshoot'];
        } else if ( docName === 'jajpalldse51' ) {
            key = 'dBUc6S_N-zKdkEA-U6sD';
            filterBy = ['jajpdseadmin51', 'jajpdsearch51', 'jajpdsedev51', 'jajpcql51'];
        } else if ( docName === 'dsecstar50' ) {
            key = '35HEzyB2mn1a1qGMmCwN';
            filterBy = ['dse50','cassandra30'];
        } else {
            if ( docName.substring(0, 4) === 'jajp' ) {
                key = 'dBUc6S_N-zKdkEA-U6sD';
            } else {
                key = '35HEzyB2mn1a1qGMmCwN';
            }
            filterBy = docName;
        }
    }
    stSearchKey = key;
    var ffields = apiFlag ? ['book','title','body','description','url','doc-name','codeblock','codeph'] : ['book','title','body','description','url','doc-name'] ;
    var sfields = apiFlag ? ['codeblock','codeph'] : ['book','title','body'] ;
    $("#st-search-input").swiftypeSearch({
        renderFunction: searchResultsRenderFunction,
        fetchFields: {'page': ffields},
        filters: {'page': {'doc-name': filterBy}},
        searchFields: {'page': sfields},
        resultContainingElement: "#st-results-container-" + activeDocName,
        engineKey: key,
        renderPaginationForType: customRenderPagination,
        postRenderFunction: customPostRenderFunction
    });
};

$("#stSearchForm").submit(inputHandlerFunction);


